# -*- coding: utf_8 -*-

from pandac.PandaModules import *
from direct.showbase import DirectObject
from direct.task import Task
from random import randint

class gameBot(object):
	Zold = 0
	Aold = 0
	a = 0
	deltaZ = 0
	speed = 0.02
	def __init__(self, model, pos, nick):
		self.loadModel(model, pos)
		self.loadLabel(nick)
		self.createCollisions()
		taskMgr.add(self.move, 'move-task-BOOT')
		time = randint(10,100)/10.0
		taskMgr.doMethodLater(time, self.rotate, 'move-task-BOOT')

	def loadModel(self, model, pos):
		tX,tY,tZ,tH,tP,tR=pos
		# пустая нода игрока для управления
		self.node = NodePath('bot')
		self.node.reparentTo(render)
		self.node.setPos(tX,tY,tZ)
		self.node.setHpr(tH,tP,tR)
		self.node.setScale(1)
		#устанавливаем маску для коллизии
		self.node.setCollideMask(BitMask32(3))
		
		# модель танка
		self.model=loader.loadModel(model)
		self.model.reparentTo(self.node)
		self.model.setScale(0.0003,0.0003,0.0003)
		# разносим танк на детали
		self.stvol = self.model.find('**/**/stvol')
		self.bashnya = self.model.find('**/**/bashnya')
		self.a = self.node.getH()
		self.Zold = self.node.getZ()
		
	def loadLabel(self, nick):
		#добавляем текст над танком
		font = loader.loadFont('arial.ttf')
		
		newTextNode = TextNode('text')
		newTextNode.setFont(font)
		newTextNode.setAlign(TextNode.ACenter)
		newTextNode.setText(nick)
		newTextNode.setShadow(0.05,0.05)
		newTextNode.setShadowColor(1, 1, 1, 0.5)
		newTextNode.setTextColor(0,0,0,1)
		newTextNode.setWordwrap(16.0)
		newTextNode.setFrameColor(0, 0, 1, 0.3)
		newTextNode.setFrameAsMargin(0.3, 0.3, 0.3, 0.3)
		newTextNode.setCardColor(1, 1, 0.5, 0.3)
		newTextNode.setCardAsMargin(0.3, 0.3, 0.3, 0.3)
		newTextNode.setCardDecal(True)
		
		text_generate = newTextNode.generate()
		
		self.newTextNodePath = render.attachNewNode(text_generate)
		self.newTextNodePath.setScale(0.08)
		self.newTextNodePath.reparentTo(self.node)
		self.newTextNodePath.setZ(0.9)
		self.newTextNodePath.setBillboardPointEye()

	def createCollisions(self):
		
		# луч для коллизии с полом и нахождения нормали к поверхности
		# 1
		self.tankGroundCol1 = CollisionNode('tankRay')
		self.tankGroundCol1.addSolid(CollisionRay(0,0,1,0,0,-1))
		self.tankGroundCol1.setFromCollideMask(BitMask32.bit(1))
		self.tankGroundCol1.setIntoCollideMask(BitMask32.allOff())
		self.tankGroundColNp1 = self.node.attachNewNode(self.tankGroundCol1)
		self.tankGroundHandler1 = CollisionHandlerQueue()
		base.cTrav.addCollider(self.tankGroundColNp1, self.tankGroundHandler1)
		
		
		# четыре шара по углам танка для коллиции с препядствиями
		# 1
		self.EnvCol1 = CollisionNode('colEnv_1')
		self.EnvCol1.addSolid(CollisionSphere(-0.25, 0.55, 0.5, 0.3))
		
		#self.EnvCol1.setIntoCollideMask(BitMask32.bit(2))
		#self.EnvCol1.setFromCollideMask(BitMask32.bit(3))
		self.EnvCol1.setIntoCollideMask(BitMask32.allOff())
		#self.EnvCol1.setFromCollideMask(BitMask32.allOff())
		
		self.EnvColNp1 = self.node.attachNewNode(self.EnvCol1)
		self.pusher1 = CollisionHandlerPusher()
		self.pusher1.addCollider(self.EnvColNp1, self.node)
		base.cTrav.addCollider(self.EnvColNp1, self.pusher1)
		
		# 2
		self.EnvCol2 = CollisionNode('colEnv_2')
		self.EnvCol2.addSolid(CollisionSphere(0.25, 0.55, 0.5, 0.3))
		
		#self.EnvCol2.setIntoCollideMask(BitMask32.bit(2))
		#self.EnvCol2.setFromCollideMask(BitMask32.bit(3))
		self.EnvCol2.setIntoCollideMask(BitMask32.allOff())
		#self.EnvCol2.setFromCollideMask(BitMask32.allOff())
		
		self.EnvColNp2 = self.node.attachNewNode(self.EnvCol2)
		self.pusher2 = CollisionHandlerPusher()
		self.pusher2.addCollider(self.EnvColNp2, self.node)
		base.cTrav.addCollider(self.EnvColNp2, self.pusher2)
		
		# 3
		self.EnvCol3 = CollisionNode('colEnv_3')
		self.EnvCol3.addSolid(CollisionSphere(-0.25, -0.55, 0.5, 0.3))
		
		#self.EnvCol3.setIntoCollideMask(BitMask32.bit(2))
		#self.EnvCol3.setFromCollideMask(BitMask32.bit(3))
		self.EnvCol3.setIntoCollideMask(BitMask32.allOff())
		#self.EnvCol3.setFromCollideMask(BitMask32.allOff())
		
		self.EnvColNp3 = self.node.attachNewNode(self.EnvCol3)
		self.pusher3 = CollisionHandlerPusher()
		self.pusher3.addCollider(self.EnvColNp3, self.node)
		base.cTrav.addCollider(self.EnvColNp3, self.pusher3)

		# 4
		self.EnvCol4 = CollisionNode('colEnv_3')
		self.EnvCol4.addSolid(CollisionSphere(0.25, -0.55, 0.5, 0.3))
		
		#self.EnvCol4.setIntoCollideMask(BitMask32.bit(2))
		#self.EnvCol4.setFromCollideMask(BitMask32.bit(3))
		self.EnvCol4.setIntoCollideMask(BitMask32.allOff())
		#self.EnvCol4.setFromCollideMask(BitMask32.allOff())
		
		self.EnvColNp4 = self.node.attachNewNode(self.EnvCol4)
		self.pusher4 = CollisionHandlerPusher()
		self.pusher4.addCollider(self.EnvColNp4, self.node)
		base.cTrav.addCollider(self.EnvColNp4, self.pusher4)
		
		"""
		self.tankGroundColNp1.show()
		self.EnvColNp1.show()
		self.EnvColNp2.show()
		self.EnvColNp3.show()
		self.EnvColNp4.show()
		"""
		
	def rotate(self, task):
		self.a = randint(-180,180)
		return Task.again
	
	def move(self, task):
		elapsed = globalClock.getDt()		
		#
		startpos = self.node.getPos()
		####################################################################################
		# вычисление высоты танка по поверхности 1
		entries = []
		for i in range(self.tankGroundHandler1.getNumEntries()):
			entry = self.tankGroundHandler1.getEntry(i)
			entries.append(entry)
		entries.sort(lambda x,y: cmp(y.getSurfacePoint(render).getZ(),x.getSurfacePoint(render).getZ()))
		
		if (len(entries)>0):
			Znew=entries[0].getSurfacePoint(render).getZ()
			self.deltaZ = abs(Znew - self.Zold)
			self.node.setZ(Znew)
		else:
			self.node.setPos(startpos)
		
		# самое интересное попытка наклонять танк повторяя поверхность по которой он движется - в разработке
		if entries:
			angleP=(180*entries[0].getInto().getNormal().getY())/3.1415
			#
			n = entries[0].getInto().getNormal()
			q = Quat()
			povorot = self.Aold - (self.Aold - self.a)/10
			self.Aold = povorot
			q.setFromAxisAngle(povorot,n)
			self.node.setQuat(q)
			self.node.setP(self.node, -angleP)
			self.Zold = self.node.getZ()
			
		#######################################################################
		#base.cTrav.traverse(render)
		#base.cTrav.showCollisions(render)
		self.node.setY(self.node, self.speed)
		#выходим из обработчика
		return Task.cont
		#return Task.again

	def move1(self, task):
		elapsed = globalClock.getDt()		
		#
		startpos = self.node.getPos()
		####################################################################################
		# вычисление высоты танка по поверхности 1
		entries = []
		for i in range(self.tankGroundHandler1.getNumEntries()):
			entry = self.tankGroundHandler1.getEntry(i)
			entries.append(entry)
		entries.sort(lambda x,y: cmp(y.getSurfacePoint(render).getZ(),x.getSurfacePoint(render).getZ()))
		
		if (len(entries)>0):
			# смягчаем прыжок по Z тут какраз и нужен тег который мы задали в начале
			Znew=entries[0].getSurfacePoint(render).getZ()
			
			deltaZ = (Znew - self.Zold)/1.2
			self.node.setZ(Znew-deltaZ)
			
			if (self.Zold - Znew)>0.1:
				#self.node.setY(self.node, elapsed*2)
				pass
			
			if (self.Zold - Znew)>0.05:
				self.EnvColNp1.setZ(1)
				self.EnvColNp2.setZ(1)
				self.EnvColNp3.setZ(1)
				self.EnvColNp4.setZ(1)
			else:
				self.EnvColNp1.setZ(0)
				self.EnvColNp2.setZ(0)
				self.EnvColNp3.setZ(0)
				self.EnvColNp4.setZ(0)
			
			self.Zold = self.node.getZ()
			
		else:
			self.node.setPos(startpos)
		
		# самое интересное попытка наклонять танк повторяя поверхность по которой он движется - в разработке
		if entries:
			angleH=(180*entries[0].getInto().getNormal().getX())/3.1415
			angleP=(180*entries[0].getInto().getNormal().getY())/3.1415
			angleR=-(180*(entries[0].getInto().getNormal().getZ()-1))/3.1415
			#
			n = entries[0].getInto().getNormal()
			q = Quat()
			q.setFromAxisAngle(self.a,n)
			self.node.setQuat(q)
			self.node.setP(self.node, -angleP)

		#######################################################################
		base.cTrav.traverse(render)
		
		#выходим из обработчика
		return Task.cont
	
	
